!= Module DynFunc
!
! Authors::   SUGIYAMA Ko-ichiro, ODAKA Masatsugu 
! Version::   $Id: dynamic_mixrt.f90,v 1.1 2011-04-26 04:08:10 sugiyama Exp $ 
! Tag Name::  $Name:  $
! Copyright:: Copyright (C) GFD Dennou Club, 2007. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!ǥϳز׻뤿ɬפȤʤؿ«ͤ⥸塼
!Ūˤϰʲι׻뤿δؿǼ.  
!  * ή
!  * Ϲ
!  * Ϲ
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * ʡؿζΥˤ, 2 ٤ΥۤѤƤ뤿, Ϲη׻ץˤ differentiate_center4 ⥸塼ꤹ뤳ȤϤǤʤΤ.
!
!== Future Plans
!

module Dynamic_mixrt
  !
  !۳Ѥϳزγƹη׻⥸塼. 
  !Ūˤϰʲι׻뤿δؿǼ.  
  !  * ή
  !  * Ϲ
  !  * Ϲ
  !

  !⥸塼ɤ߹
  use dc_types, only: DP

  use gridset, only:  imin,           &! x β
    &                 imax,           &! x ξ
    &                 jmin,           &! y β
    &                 jmax,           &! y ξ
    &                 kmin,           &! z β
    &                 kmax,           &! z ξ
    &                 nx,ny,nz,nf      !
  use basicset, only: xyza_MixRtBasicZ    !ܾκ
  use constants,only: CpDry,             &!ʬǮ
    &                 Grav,              &!ϲ®
    &                 NuV, NuH,          &!ͳȻ
    &                 Nu,                &!Ȥθ그
    &                 Grav                !ϲ®
  use moistset, only: SpcWetSymbol
  use axesset, only: &
    &                xyz_avr_pyz, xyr_avr_pyr, xqz_avr_pqz, &
    &                pyz_avr_xyz, pyr_avr_xyr, pqz_avr_xqz, &
    &                xyz_avr_xqz, pyz_avr_pqz, xyr_avr_xqr, &
    &                xqz_avr_xyz, pqz_avr_pyz, xqr_avr_xyr, &
    &                xyz_avr_xyr, pyz_avr_pyr, xqz_avr_xqr, &
    &                xyr_avr_xyz, pyr_avr_pyz, xqr_avr_xqz 

  !ۤηػ
  implicit none

  !°λ
  private

  !public 
  public Dynamic_MixRt_init
  public Tendency_Dynamic_MixRt


contains

  subroutine Dynamic_MixRt_init

    use gtool_historyauto, only: HistoryAutoAddVariable

    implicit none

    integer :: l

    do l = 1, nf
      call HistoryAutoAddVariable(  &
        & varname=trim(SpcWetSymbol(l))//'_Adv', &
        & dims=(/'x','y','z','t'/),     &
        & longname='Advection term of '          &
        &           //trim(SpcWetSymbol(l))//' mixing ratio',  &
        & units='kg.kg-1.s-1',    &
        & xtype='double')
      
      call HistoryAutoAddVariable(  &
        & varname=trim(SpcWetSymbol(l))//'_Diff', & 
        & dims=(/'x','y','z','t'/),     &
        & longname='Diffusion term of '          &
        &           //trim(SpcWetSymbol(l))//' mixing ratio',  &
        & units='kg.kg-1.s-1',    &
        & xtype='double')
    end do

  end subroutine Dynamic_MixRt_init

!!!------------------------------------------------------------------------!!!

  subroutine Tendency_Dynamic_MixRt(    &
    & Time, pyz_VelXNl, xqz_VelYNl, xyr_VelZNl, xyza_MixRtBl, xyza_MixRtNl, xyza_Dyn )
    ! ̤ΰήȻη׻ 
    ! Advection and diffusion of potential temperature.
    !

    implicit none

    real(DP), intent(in)  :: Time
    real(DP), intent(in)  :: pyz_VelXNl(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xqz_VelYNl(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xyr_VelZNl(imin:imax, jmin:jmax, kmin:kmax)
    real(DP), intent(in)  :: xyza_MixRtBl(imin:imax, jmin:jmax, kmin:kmax, nf)
    real(DP), intent(in)  :: xyza_MixRtNl(imin:imax, jmin:jmax, kmin:kmax, nf)
    real(DP), intent(out) :: xyza_Dyn(imin:imax, jmin:jmax, kmin:kmax, nf)

    real(DP) :: xyza_Adv(imin:imax, jmin:jmax, kmin:kmax, nf)
    real(DP) :: xyza_Diff(imin:imax, jmin:jmax, kmin:kmax, nf)
    integer :: l

    xyza_Adv  = xyza_AdvScalar(xyza_MixRtNl + xyza_MixRtBasicZ, pyz_VelXNl, xqz_VelYNl, xyr_VelZNl)
    xyza_Diff = xyza_NumDiffScalar(xyza_MixRtBl) 
    
    xyza_Dyn = xyza_Adv + xyza_Diff 
    
    ! Output
    do l = 1, nf
      call HistoryAutoPut(Time, trim(SpcWetSymbol(l))//'_Adv',  xyza_Adv(1:nx,1:ny,1:nz,l))
      call HistoryAutoPut(Time, trim(SpcWetSymbol(l))//'_Diff', xyza_Diff(1:nx,1:ny,1:nz,l))
    end do
    
  end subroutine Tendency_Dynamic_MixRt

!!!-------------------------------------------------------------------!!!
  function xyza_NumDiffScalar(xyza_Scalar)
    !
    ! x, z ȾʻҤ줿ǤοͳȻɾ
    !
    use xyz_deriv_module, only: xyz_dx_pyz, pyz_dx_xyz, xyz_dy_xqz, xqz_dy_xyz, xyz_dz_xyr, xyr_dz_xyz
    
    !ۤηػ
    implicit none    

    !ѿ
    real(DP), intent(in) :: xyza_Scalar &
      &                     (imin:imax,jmin:jmax,kmin:kmax,nf)
                                                    !顼
    real(DP)             :: xyza_NumDiffScalar &
      &                     (imin:imax,jmin:jmax,kmin:kmax,nf)
                                                    !ʿοͳȻ
    integer             :: s
    

    do s = 1, nf
      xyza_NumDiffScalar(:,:,:,s) =   &
        &    NuH * (xyz_dx_pyz(pyz_dx_xyz( xyza_Scalar(:,:,:,s) ))) &
        &  + NuH * (xyz_dy_xqz(xqz_dy_xyz( xyza_Scalar(:,:,:,s) ))) &
        &  + NuV * (xyz_dz_xyr(xyr_dz_xyz( xyza_Scalar(:,:,:,s) ))) 
    end do

  end function xyza_NumDiffScalar


!!!------------------------------------------------------------------------!!!
  function xyza_AdvScalar(xyza_Var, pyz_VelX, xqz_VelY, xyr_VelZ)
    !
    ! x, z ȾʻҤ줿ˤή׻
    !
    
    !⥸塼ɤ߹
    use xyz_deriv_c4_module, only: pyz_dx_xyz, xqz_dy_xyz, xyr_dz_xyz
!    use xyz_deriv_module, only: pyz_dx_xyz, xqz_dy_xyz, xyr_dz_xyz

    !ۤηػ
    implicit none
    
    !ѿ
    real(DP), intent(in) :: pyz_VelX &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                                        !ʿ®
    real(DP), intent(in) :: xqz_VelY &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                                        !ʿ®
    real(DP), intent(in) :: xyr_VelZ &
      &                    (imin:imax,jmin:jmax,kmin:kmax)
                                                        !ľ®
    real(DP), intent(in) :: xyza_Var &
      &                    (imin:imax,jmin:jmax,kmin:kmax,nf)
                                                        !顼
    real(DP)             :: xyza_AdvScalar &
      &                    (imin:imax,jmin:jmax,kmin:kmax,nf)
                                                        !顼̤οʿή
    integer :: s ! 롼ѿ

    do s = 1, nf        
      xyza_AdvScalar(:,:,:,s) =                                  &
        & - xyz_avr_pyz(pyz_VelX * pyz_dx_xyz(xyza_Var(:,:,:,s))) &
        & - xyz_avr_xqz(xqz_VelY * xqz_dy_xyz(xyza_Var(:,:,:,s))) &
        & - xyz_avr_xyr(xyr_VelZ * xyr_dz_xyz(xyza_Var(:,:,:,s)))    
    end do

  end function xyza_AdvScalar
 
end module Dynamic_mixrt
